#############################################################################
#
# Copyright (c) 2011 Zope Foundation and Contributors.
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################

import io


def create_summary(messages, start, end):
    messages = sorted(messages, key=lambda m: m.description)
    out = io.StringIO()

    print("This is the summary for test reports received on the ", file=out)
    print("zope-tests list between %s UTC and %s UTC:" % (
        start.isoformat(' '), end.isoformat(' ')), file=out)
    print(file=out)
    print("See the footnotes for test reports of unsuccessful builds.", file=out)
    print(file=out)
    print("An up-to date view of the builders is also available in our ", file=out)
    print("buildbot documentation: ", file=out)
    print("http://docs.zope.org/zopetoolkit/process/buildbots.html"\
                 "#the-nightly-builds", file=out)
    print(file=out)
    print("Reports received", file=out)
    print("----------------", file=out)
    print(file=out)

    foot_notes = []
    for message in messages:
        ref = ''
        if message.status != 'OK':
            foot_notes.append(message)
            ref = '[%s]' % len(foot_notes)
        print((ref).ljust(6), message.description, file=out)

    print(file=out)
    print("Non-OK results", file=out)
    print("--------------", file=out)
    print(file=out)

    for i, message in enumerate(foot_notes):
        print(('[%s]' % (i+1)).ljust(6), \
                      message.status.ljust(7), \
                      message.description, file=out)
        print(' '*6, message.url, file=out)
        print(file=out)
        print(file=out)

    return out.getvalue()
